package usercontroller

import (
    "net/http"
)

type IController interface {
    POST(w http.ResponseWriter, r *http.Request)
    GET(w http.ResponseWriter, r *http.Request)
    DELETE(w http.ResponseWriter, r *http.Request)
    PUT(w http.ResponseWriter, r *http.Request)
}
type Controller struct {
    IController IController
}

func GenerateController(controller IController) Controller {
    return Controller { controller }
}

func (self Controller) ServeHTTP(w http.ResponseWriter, r *http.Request) {
    if r.Method == "POST" {
        self.POST(w, r)
        return
    }
    if r.Method == "GET" {
        self.GET(w, r)
        return
    }
    if r.Method == "DELETE" {
        self.DELETE(w, r)
        return
    }
    if r.Method == "PUT" {
       self.PUT(w, r)
       return
    }
    http.Error(w, http.StatusText(http.StatusNotFound), http.StatusNotFound)
}

func (self Controller) POST(w http.ResponseWriter, r *http.Request) {
    self.IController.POST(w, r)
}

func (self Controller) GET(w http.ResponseWriter, r *http.Request) {
    self.IController.GET(w, r)
}

func (self Controller) DELETE(w http.ResponseWriter, r *http.Request) {
    self.IController.DELETE(w, r)
}

func (self Controller) PUT(w http.ResponseWriter, r *http.Request) {
    self.IController.PUT(w, r)
}
